'Program to control super_bot
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


  UpperLimit    = 2100            'Set Maximum allowed pulse width
  LowerLimit    =  900            'Set Minimum allowed pulse width
  LeftMotor     = 7                '910 is full bore one way
  RightMotor    = 6                '2090 is full bore the other way
  Forward       = 950              '1600 is stop
  Backward      = 2050
  Stop          = 1600
  PING_Pin      = 1
  

Var
        long      range    
Obj
        ping : "ping"
Pub start
   repeat 20
   Stop_Motion
    repeat
     Forward_Motion
      range := ping.Inches(PING_Pin)  
      if range < 6
        Backward_motion
        Turn_Right
      
           
PUB Stop_Motion
      Left(LeftMotor,Stop)
      Right(RightMotor,Stop)
PUB Forward_Motion 

      Left(LeftMotor,Forward)              
      Right(RightMotor,Forward)

PUB Backward_Motion 
     repeat 200
      Left(LeftMotor,Backward)
      Right(RightMotor,Backward)

PUB Turn_Right
     repeat 150
      Left(LeftMotor,Forward)
      Right(RightMotor,Backward)

PUB Turn_Left 
     repeat 150
      Left(LeftMotor,Backward)
      Right(RightMotor,Forward)   
    
PRI LEFT(Pin,Duration) | ClkCycles
    Duration := LowerLimit #> ||Duration <# UpperLimit 
    ClkCycles := Duration * (clkfreq / 1_000_000) - 1050
    dira[pin]~~
    waitcnt(ClkCycles + cnt)
    outa[pin]~~                                 
    waitcnt(ClkCycles + cnt)                             
    outa[pin]~                                 

PRI RIGHT(Pin,Duration) | ClkCycles
    Duration := LowerLimit #> ||Duration <# UpperLimit 
    ClkCycles := Duration * (clkfreq / 1_000_000) - 1050
    dira[pin]~~
    waitcnt(ClkCycles + cnt)
    outa[pin]~~                                 
    waitcnt(ClkCycles + cnt)                             
    outa[pin]~                      